<?php
/**
 * Configuration file
 *
 *
 *	This file is part of queXS
 *	
 *	queXS is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *	
 *	queXS is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *	
 *	You should have received a copy of the GNU General Public License
 *	along with queXS; if not, write to the Free Software
 *	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 *
 * @author Adam Zammit <adam.zammit@deakin.edu.au>
 * @copyright Deakin University 2007,2008
 * @package queXS
 * @subpackage configuration
 * @link http://www.deakin.edu.au/dcarf/ queXS was writen for DCARF - Deakin Computer Assisted Research Facility
 * @license http://opensource.org/licenses/gpl-2.0.php The GNU General Public License (GPL) Version 2
 * 
 */


/**
 *
 * Only some of the configuration directives are here. See the file: config.default.php for them all
 *
 * Make your configuration changes in this file only - they will "overwrite" the default configuration
 *
 */

/**
 * The default time zone
 */
define('DEFAULT_TIME_ZONE', 'Australia/Victoria');

/**
 * Flag for VoIP with Asterisk to be enabled or not
 */
define('VOIP_ENABLED',false);

/**
 * The Asterisk server address
 */
define('VOIP_SERVER','asterisk.dcarf');

/**
 * Whether to automatically pop up a coding window when the respondent hangs up
 */
define('AUTO_POPUP',false);

/**
 * The path to queXS from the server root
 */
define('QUEXS_PATH', '/quexs/');

define('HTPASSWD_PATH',dirname(__FILE__) . "\..\..\security\quex.htpasswd");
define('HTGROUP_PATH',dirname(__FILE__) . "\..\..\security\quex.htgroup");

define('WINDOWS_PHP_EXEC', dirname(__FILE__) . '\..\..\bgrun\bgrun.exe ' . dirname(__FILE__) . '\..\..\php\php.exe');

/**
 * Database configuration for queXS
 */
define('DB_USER', 'root');
define('DB_PASS', '');
define('DB_HOST', 'localhost');
define('DB_NAME', 'quexs');

?>
